#
# list_cgi.py - List CGI methods.
# Copyright (C) 2005  shinGETsu Project.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: list_cgi.py,v 1.12 2005/05/05 02:50:55 fuktommy Exp $
#

import cgi

import config
import gateway
from cache import *

__version__ = "$Revision: 1.12 $"


class CGI(gateway.CGI):

    """Class for /list.cgi."""

    appli_type = "list"

    def run(self):
        path = self.path_info()

        if path == "":
            path = config.menu

        form = cgi.FieldStorage(environ=self.environ, fp=self.stdin)
        if form.getfirst("cmd", "") == "new" and \
           form.getfirst("file", "").startswith("list_") and \
           self.environ["REQUEST_METHOD"] == "POST":
            flag = self.do_new_element(path, form)
            if not flag:
                return
            datfile = form.getfirst("file", "")
            title = self.str_encode(self.file_decode(datfile))
            self.print302(self.list_cgi + self.sep + title)
            return

        self.print_list(path)


    def print_list(self, path):
        cache = Cache(self.file_encode("list", path))
        if not re.search(config.robot, self.environ["HTTP_USER_AGENT"]):
            self.get_cache(cache)
        self.header(path)
        self.stdout.write(
            '<form method="get" action="' + self.admin_cgi + '">\n' +
            '<p>\n' +
            '  <input type="hidden" name="cmd" value="delete" />\n' +
            '  <input type="hidden" name="file" value="%s" />\n' %
            cache.datfile +
            '</p>\n' +
            '<ul>\n')
        buf = []
        stamp = {}
        for rec in cache.load_body():
            (bufstr, st) = self.record_to_string(cache, rec)
            buf.append(bufstr)
            stamp[bufstr] = st
        buf.sort(lambda a,b: cmp(stamp[b], stamp[a]))
        for recstr in buf:
            self.stdout.write(recstr+"\n")
        self.print_form(cache)
        self.remove_file_form(cache)
        self.footer()

    def record_to_string(self, cache, rec):
        stamp = rec["stamp"]

        buf = "  <li>\n" + \
              '    <input type="radio" name="record"' + \
              ' value="' + rec["stamp"] + "_" + rec["id"] + '"' + \
              ' tabindex="1" accesskey="s" />\n'

        if ("type" in rec) and ("link" in rec):
            child_datfile = self.file_encode(rec["type"], rec["link"])
            child = Cache(child_datfile)
            if len(child) > 0:
                records = str(len(child))
            else:
                records = "?"

            if child.stamp > 0:
                stamp = child.stamp

            chstamp = self.localtime(stamp)
            chname = self.str_encode(rec["link"])
            if rec["type"] in config.types:
                anchor = '<a href="' + self.appli[rec["type"]] + self.sep + \
                         chname + '">' + rec["link"] + "</a>"
                msgtype = self.message[rec["type"]]
            else:
                anchor = rec["link"]
                msgtype = rec["type"]


            buf += '    ' + chstamp + "\n" + \
                   '    ' + anchor + "\n" + \
                   '    (' + msgtype + "/" + records + "/" + \
                   str(child.size*10/1024/1024/10.0) + \
                   self.message["mb"] + ")\n"

	if ("remove_stamp" in rec) and ("remove_id" in rec):
            chstamp = self.localtime(rec["remove_stamp"])
            buf += "    " + chstamp + " " + self.message["remove"] + ":\n"

        if "name" in rec:
            buf += "    " + rec["name"] + ":\n"

        if "pubkey" in rec:
            buf += '    <span class="sign" title="[%s]">%s</span>' % \
                   (rec["target"], rec["pubkey"])

        if "body" in rec:
            buf += "    " + rec["body"] + "\n"

        buf += "  </li>\n"
        return (buf, int(stamp))

    def print_form(self, cache):
        self.stdout.write(
            "</ul>\n" +
            "<p>\n" + 
            '  <input type="submit" value="' + 
            self.message["del_record"] + '" tabindex="2" accesskey="d" />\n' +
            "</p>\n</form>\n")

        if cache.size <= config.file_limit*1024*1024:
            self.print_new_element_form(parent=cache)
